# Copyright 2020 Gentoo Authors
# Distributed under the terms of the GNU General Public License v2

EAPI=7

DESCRIPTION="Quickly compare files for identity"
HOMEPAGE="https://git.flanchan.moe/flanchan/fcmp"
SRC_URI="https://git.flanchan.moe/flanchan/fcmp/archive/v${PV}.tar.gz -> ${P}.tar.gz"

LICENSE="GPL-3+"
SLOT="0"
KEYWORDS="~amd64 ~x86"

DEPEND=""
RDEPEND="${DEPEND}"
BDEPEND=""

IUSE="debug threads pgo"

REQUIRED_USE="pgo? ( !debug )"

src_unpack() {
	default
	mv ${PN} ${P}
}

src_compile() {

	local FEAT_CFLAGS
	local FEAT_LDFLAGS

	if use threads; then
		FEAT_CFLAGS="-D_RUN_THREADED=0"
		FEAT_LDFLAGS="-lpthread"
	fi

	if use debug; then
		FEAT_CFLAGS="${FEAT_CFLAGS}" FEAT_LDFLAGS="${FEAT_LDFLAGS}" CFLAGS="" LDFLAGS="" emake debug
		mv ${PN}-debug ${PN}
	elif use pgo; then
		FEAT_CFLAGS="${FEAT_CFLAGS}" FEAT_LDFLAGS="${FEAT_LDFLAGS}" RELEASE_CFLAGS="" RELEASE_LDFLAGS="" emake pgo
		mv ${PN}-pgo ${PN}
	else
		FEAT_CFLAGS="${FEAT_CFLAGS}" FEAT_LDFLAGS="${FEAT_LDFLAGS}" RELEASE_CFLAGS="" RELEASE_LDFLAGS="" default
		mv ${PN}-release ${PN}
	fi
}

src_install() {
	dobin ${PN}
}
