# Copyright 2020 Gentoo Authors
# Distributed under the terms of the GNU General Public License v2

EAPI=7

DESCRIPTION="3 stage byte shuffler"
HOMEPAGE=""
SRC_URI="https://git.flanchan.moe/flanchan/shuffle3/archive/v${PV}.tar.gz -> ${P}.tar.gz"

LICENSE="GPL-3+"
SLOT="0"
KEYWORDS="~amd64 ~x86"

DEPEND=""
RDEPEND="${DEPEND}"
BDEPEND=""

IUSE="debug pgo spill verbose"

REQUIRED_USE="pgo? ( !debug )"

src_unpack() {
	default
	mv ${PN}{,-${PV}}
}

src_compile() {
	local FEATURE_FLAGS

	FEATURE_FLAGS=""
	use spill	&& FEATURE_FLAGS+="_FS_SPILL_BUFFER=DYN "
	use verbose	&& FEATURE_FLAGS+="DEBUG"

	if use debug; then
		FEATURE_FLAGS="${FEATURE_FLAGS}" CFLAGS="" CXXFLAGS="" LDFLAGS="" emake debug
		mv ${PN}{-debug,}
	elif use pgo; then
		FEATURE_FLAGS="${FEATURE_FLAGS}" RELEASE_CFLAGS="" RELEASE_CXXFLAGS="" RELEASE_LDFLAGS="" emake pgo
		mv ${PN}{-pgo,}
	else
		FEATURE_FLAGS="${FEATURE_FLAGS}" RELEASE_CFLAGS="" RELEASE_CXXFLAGS="" RELEASE_LDFLAGS="" default
		mv ${PN}{-release,}
	fi
}

src_install() {
	dobin ${PN}
}
